//: ## Playground: Formatted Strings
import Cocoa

let name = ""
let email = ""
let section = ""

/*:
We've already learned about string interpolation. It looks like this.

    print("The value of Pi is \(M_PI)")

Let's see what it outputs.
*/
////////// Lab 1 //////////





/*:
There it is, in all its 14-decimal-place glory.

    The value of Pi is 3.14159265358979

What if we want to display it like this, with only a few decimal places? And let's round to the nearest value we're showing.

    The value of Pi is 3.142

String interpolation does not help us here. We need to use string formatting instead. How to do this can be quite different in different languages. Here's how Swift does it. We'll start with an example.

---

#### **Format Codes**
![format 1](format01.png)

The different between **`%f`** and **`\( )`** is that a format code can be configured to display how we want it to. Also, there are different codes for different data types. Here are some common ones.

![format 4](format04.png)

To see more of them open a browser window and search the internet for "printf format codes". The **`printf`** is from C and so are the format codes. This search will result in lots of sites with more information.

---

Another great feature of format codes is being able to specify how things are formatted. In our example with Pi we just need to do this.

    let formattedString = String(format: "The value of Pi is %.3f", M_PI)
    print(formattedString)

Try it!
*/
////////// Lab 2 //////////





/*:
We get this.

    The value of Pi is 3.142

How did that happen?

![format 2](format02.png)

We can also put a value in front of the **`.3`** in our example. Let's try it. We can also just put the formatting right inside a **`print()`** like this. Enter all these so we can see what happens.

    print(String(format: "%9.3f", M_PI))
    print(String(format: "%9.3f", 1.2))
    print(String(format: "%9.3f", 123.456789))
    print(String(format: "%9.3f", 80000.0))
*/
////////// Lab 3 //////////





/*:
        3.142
        1.200
      123.457
    80000.000

The confusing part can be the difference between the **9** and the **3**. The number to the left of the period is the **total** number of spaces that will be used. (It is not how many spaces to the left of the period.) The number to the right of the period is the number of decimal places to display.

![format 3](format03.png)

### **Wrap Up**

That's it for this topic, for now.
*/